#include <Servo.h>
#include "takeonme.h"
#include "nevergonnagiveuup.h"
#include "mario.h"

const int SEN_PIN1 = A0;
const int SEN_PIN2 = A1;

const int MOUTH_SVO_PIN1 = 8;
const int MOUTH_SVO_PIN2 = 7;
const int LEFT_LEG_SVO_PIN = 2;
const int RGHT_LEG_SVO_PIN = 4;

Servo mouth_svo1, mouth_svo2, l_leg_svo, r_leg_svo;

const int SVO1_OPEN = 80;
const int SVO2_OPEN = 100;
const int SVO1_CLOSE = 130;
const int SVO2_CLOSE = 50;

const int SEN1_THRES = 890;
const int SEN2_THRES = 890;

long chew_t = 0;
long chew_start = 0;

void setup() {
  Serial.begin(9600);

  mouth_svo1.attach(MOUTH_SVO_PIN1);
  mouth_svo2.attach(MOUTH_SVO_PIN2);
  l_leg_svo.attach(LEFT_LEG_SVO_PIN);
  r_leg_svo.attach(RGHT_LEG_SVO_PIN);

  open_mouth();
  l_leg_svo.write(70);
  r_leg_svo.write(110);
}

long start_t = millis();
void loop() {
  long curr_t = millis();

  int sen1_val = analogRead(SEN_PIN1);
  int sen2_val = analogRead(SEN_PIN2);
  
  Serial.print(chew_t);
  Serial.print("\t");
  Serial.print("");
  Serial.print("\t");
  Serial.print(sen1_val);
  Serial.print("\t");
  Serial.println(sen2_val);

  if ((sen1_val < SEN1_THRES) || (sen2_val < SEN2_THRES)) {
    if (curr_t - start_t > 500) {
      start_t = curr_t;
      if (chew_t < 10) {
        chew_t = curr_t;
        chew_start = chew_t;
        close_mouth();
        delay(100);
      }
    }
  }
  else if (random(5000) == 1) {
    close_mouth();
    delay(1000);
    open_mouth();
    play_nggup();
    delay(1000);
    close_mouth();
    delay(1000);
    open_mouth();
  }
  else if (random(5000) == 7) {
    lean_forward();
    play_takeonme();
  }

  if (500 < chew_t) {
    chew(curr_t);
    chew_t = curr_t;
    if (chew_t - chew_start > 5000) {
      chew_t = 0;
      open_mouth();
      delay(random(200, 500));
      play_mario();
      lean();
    }
  }
}

void chew(long curr_t) {
  int a = 6;
  int x0 = 55;
  mouth_svo2.write(a*sinf((float)curr_t/150) + x0);
  mouth_svo1.write(-a*sinf((float)curr_t/150) + (180-x0));
}

void open_mouth() {
  mouth_svo1.write(SVO1_OPEN);
  mouth_svo2.write(SVO2_OPEN);
}

void close_mouth() {
  mouth_svo1.write(SVO1_CLOSE);
  mouth_svo2.write(SVO2_CLOSE);
}

void lean_forward() {
  l_leg_svo.write(140);
  r_leg_svo.write(30);
  delay(random(2000, 4000));
  l_leg_svo.write(70);
  r_leg_svo.write(110);
  delay(1000);
}

void lean() {
  l_leg_svo.write(140);
  r_leg_svo.write(30);
  delay(random(2000, 4000));
  close_mouth();
  l_leg_svo.write(70);
  r_leg_svo.write(110);
  delay(1000);
  open_mouth();
}
